/*
 * (C) Copyright 2001
 * Rob Taylor, Flying Pig Systems. robt@flyingpig.com.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <ppcboot.h>
#include <mpc8240.h>
#include <asm/processor.h>

#define BOARD_REV_REG 0xFE80002B

int checkboard(void)
{
	char  revision = *(volatile char *)(BOARD_REV_REG);
	ulong busfreq  = get_bus_freq(0);
	char  buf[32];

	printf("CU824 ");
	printf("Revision %d ", revision);
	printf("Local Bus at %s MHz\n", strmhz(buf, busfreq));

	return 0;
}

long int initdram(int board_type)
{
#if 0
	int val;

	printf("\n");
#if 1
	CONFIG_READ_HALFWORD(PCICR, val);
	printf("PCICR = 0x%04X\n", val);
	CONFIG_READ_WORD(PICR1, val);
	printf("PICR1 = 0x%08X\n", val);
	CONFIG_READ_HALFWORD(PCISR, val);
	printf("PCISR = 0x%04X\n", val);
	CONFIG_READ_WORD(PICR2, val);
	printf("PICR2 = 0x%08X\n", val);
	CONFIG_READ_WORD(EUMBBAR, val);
	printf("EMUMBAR = 0x%08X\n", val);
	CONFIG_READ_WORD(MCCR1, val);
	printf("MCCR1 = 0x%08X\n", val);
	CONFIG_READ_WORD(MCCR2, val);
	printf("MCCR2 = 0x%08X\n", val);
	CONFIG_READ_WORD(MCCR3, val);
	printf("MCCR3 = 0x%08X\n", val);
	CONFIG_READ_WORD(MCCR4, val);
	printf("MCCR4 = 0x%08X\n", val);
	CONFIG_READ_WORD(MSAR1, val);
	printf("MSAR1 = 0x%08X\n", val);
	CONFIG_READ_WORD(EMSAR1, val);
	printf("EMSAR1 = 0x%08X\n", val);
	CONFIG_READ_WORD(MSAR2, val);
	printf("MSAR2 = 0x%08X\n", val);
	CONFIG_READ_WORD(EMSAR2, val);
	printf("EMSAR2 = 0x%08X\n", val);
	CONFIG_READ_WORD(MEAR1, val);
	printf("MEAR1 = 0x%08X\n", val);
	CONFIG_READ_WORD(EMEAR1, val);
	printf("EMEAR1 = 0x%08X\n", val);
	CONFIG_READ_WORD(MEAR2, val);
	printf("MEAR2 = 0x%08X\n", val);
	CONFIG_READ_WORD(EMEAR2, val);
	printf("EMEAR2 = 0x%08X\n", val);
	CONFIG_READ_BYTE(ODCR, val);
	printf("ORCR = 0x%02X\n", val);
	CONFIG_READ_BYTE(MBER, val);
	printf("MBER = 0x%02X\n", val);
#endif
   CONFIG_READ_WORD(MCCR1, val);
   CONFIG_WRITE_WORD(MCCR1, val | MCCR1_MEMGO); //set memory access going
   __asm__ __volatile__("eieio");
	 CONFIG_READ_WORD(MCCR1, val);
	 printf("MCCR1 = 0x%08X\n", val);

	printf("IBAT0L = 0x%08X\n", mfspr(IBAT0L));
	printf("IBAT0U = 0x%08X\n", mfspr(IBAT0U));
	printf("IBAT1L = 0x%08X\n", mfspr(IBAT1L));
	printf("IBAT1U = 0x%08X\n", mfspr(IBAT1U));
	printf("IBAT2L = 0x%08X\n", mfspr(IBAT2L));
	printf("IBAT2U = 0x%08X\n", mfspr(IBAT2U));
	printf("IBAT3L = 0x%08X\n", mfspr(IBAT3L));
	printf("IBAT3U = 0x%08X\n", mfspr(IBAT3U));
	printf("DBAT0L = 0x%08X\n", mfspr(DBAT0L));
	printf("DBAT0U = 0x%08X\n", mfspr(DBAT0U));
	printf("DBAT1L = 0x%08X\n", mfspr(DBAT1L));
	printf("DBAT1U = 0x%08X\n", mfspr(DBAT1U));
	printf("DBAT2L = 0x%08X\n", mfspr(DBAT2L));
	printf("DBAT2U = 0x%08X\n", mfspr(DBAT2U));
	printf("DBAT3L = 0x%08X\n", mfspr(DBAT3L));
	printf("DBAT3U = 0x%08X\n", mfspr(DBAT3U));

	printf("huy = 0x%08X\n", (CFG_ROMNAL << MCCR1_ROMNAL_SHIFT) |
                             (CFG_ROMFAL << MCCR1_ROMFAL_SHIFT));
	printf("huy = 0x%08X\n", (CFG_ROMNAL << MCCR1_ROMNAL_SHIFT) |
                             (CFG_ROMFAL << MCCR1_ROMFAL_SHIFT) | MCCR1_MEMGO);
#endif

	return CFG_RAM_SIZE;
}


